// brent method(ug@)@`̐l
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.Series,
  Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, VCLTee.TeEngine, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Series3: TPointSeries;
    Series4: TPointSeries;
    LabeledEdit3: TLabeledEdit;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure chart_graph(a, b: double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// ֐f(x)̌vZ@`
function f(x: double): double;
begin
  result := (x + 3) * (x - 1) * (x - 1);
end;

// [a,b]̊֐f(x)̃Ot}
procedure TForm1.chart_graph(a, b: double);
const
  n = 100;
var
  x, xs, xe, dx: double;
  ys, ye, dy : double;
  y : double;
  i : integer;
begin
  series1.clear;
  series2.clear;
  series3.clear;
  series4.clear;
  if a = b then exit;                     // ͈͂[I
  xs := a - (b - a) / 5;
  xe := b + (b - a) / 5;
  dx := (xe - xs) / n;
  for i := 0 to n do begin
    x := xs + i * dx;
    y := f(x);
    series1.AddXY(x, y);
  end;
  ys := f(a);
  ye := f(b);
  series3.AddXY(a, ys);
  series3.AddXY(b, ye);
  dy := (ye - ys) / (b - a);
  dx := (b - a) / n;
  for i := -20 to n + 20 do begin
    x := i * dx;
    y := (dy * x) + ys;
    series2.AddXY(x + a, y);
  end;
end;

// ug@ɂf()=0ƂȂ郿̋ߎlvZ
function brent_method(a, b, delta, epsilon: double; var loop: integer): double;
var
  e, d, c, beta, alpha, p, q, r, s : double;
begin
  c := a;
  d := b - a;
  e := d;
  while abs(f(b)) > epsilon do begin
    alpha := (a - b) / 2;
    beta := f(b) / f(c);
    if (abs(e) < delta) or (abs(f(c)) < abs(f(b))) then  begin // 񕪖@
      e := alpha;
      d := e;
    end
    else begin
      if a = c then begin                                 // `
        p := 2 * alpha * beta;
        q := 1 - beta;
      end
      else begin                                          // t񎟕
        q := f(c) / f(a);
        r := f(b) / f(a);
        p := beta * (2 * alpha * q * (q - r) - (b - c) * (r - 1));
        q := (q - 1) * (r - 1) * (beta - 1);
      end;
      beta := e;
      e := d;
      if (abs(2 * p) < abs(3 * alpha * q)) and (abs(p) < abs(beta * q / 2)) then
        d := - p / q
      else begin                                          // 񕪖@
        e := alpha;
        d := e;
      end;
    end;
    if abs(d) > delta then
      s := b + d
    else if alpha > 0 then
           s := b + delta
         else
           s := b - delta;
    c := b;
    b := s;
    if f(b) * f(a) > 0 then begin
      a := c;
      e := b - c;
      d := e;
    end;
    if abs(f(a)) < abs(f(b)) then begin
      a := b;
      b := c;
      c := b;
    end;
    inc(loop);
  end;
  result := b;
end;

// vZs
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  a, b, alpha, y : double;
  ch, loop : integer;
  delta, tmp, epsilon : double;
begin
  memo1.Clear;
  val(labelededit1.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('aɊԈႢL܂B','',0);
    exit;
  end;
  val(labelededit2.Text, b, ch);
  if ch <> 0 then begin
    application.MessageBox('bɊԈႢL܂B','',0);
    exit;
  end;
  val(labelededit3.Text, epsilon, ch);
  if ch <> 0 then begin
    application.MessageBox('lɊԈႢL܂B','',0);
    exit;
  end;
  // Ot쐬
  chart_graph(a, b);
  if a - b = 0 then begin
    application.MessageBox('͈[a,b][łB','',0);
    exit;
  end;
  if abs(f(b)) >= abs(f(a)) then begin
    application.MessageBox('|f(a)| <= |f(b)|łAύXĉB','',0);
    exit;
  end;
  if f(a) * f(b) >= 0 then begin
    application.MessageBox('f(a) * f(b) > 0AłύXĉB','',0);
    exit;
  end;
  // lvZ
  delta := 1;
  repeat
    delta := delta / 2;
    tmp := 1 + delta;
  until tmp = 1;
  delta := delta * 2;
  if epsilon < delta * 100 then begin
    application.MessageBox('l܂B','',0);
    exit;
  end;
  // `̌vZ
  loop := 0;
  alpha := brent_method(a, b, delta, epsilon, loop);
  // Z
  y := f(alpha);
  // vZʕ\
  if abs(y) > epsilon * 10 then begin
    memo1.Lines.Append('[v ' + intTostr(loop));
    memo1.lines.Append('͈[a,b]̒lf(x)=0 ͈̔͊OłB');
    memo1.lines.Append('f(x)=0̒lړ_łB');
    exit;
  end;
  series4.AddXY(alpha, y);
  memo1.Lines.Append('f(x) = (x + 3) * (x - 1)^2');
  memo1.Lines.Append('[v ' + intTostr(loop));
  memo1.Lines.Append('l');
  memo1.Lines.Append(floatTostr(epsilon));
  memo1.Lines.Append('f()=0');
  memo1.Lines.Append('= ' +floatTostr(alpha));
  memo1.Lines.Append('Z y = f()');
  memo1.Lines.Append('y= ' +floatTostr(y));
end;

end.
