// newton Method(j[g@)@`̐l
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.Series,
  Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, VCLTee.TeEngine, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TPointSeries;
    Series4: TPointSeries;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure chart_graph(a, h: double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// ֐f(x)̌vZ@`
function f(x: double): double;
begin
  result := x * x - 2;
end;

// f'(x) l
function df(x: double): double;
begin
  result := 2 * x;
end;

// [a}h]̊֐f(x)Adf(x)̃Ot}
procedure TForm1.chart_graph(a, h: double);
const
  n = 100;
var
  x, xs, xe, dx: double;
  y, dy : double;
  i : integer;
begin
  series1.clear;
  series2.clear;
  series3.clear;
  series4.clear;
  xs := (a - h);
  xe := (a + h);
  dx := (xe - xs) / n;
  dy := df(a);
  for i := 0 to n do begin
    x := xs + i * dx;
    y := f(x);
    series1.AddXY(x, y);
    y := dy * (x - a);
    series2.AddXY(x, y);
  end;
end;

// j[g@ɂf()=0ƂȂ郿̋ߎlvZ
function newton_Method(a, epsilon: double; var loop: integer): double;
var
  ah : double;
begin
  while loop < 1000 do begin
    inc(loop);
    ah := a - f(a) / df(a);
    if abs(ah - a) <= epsilon * abs(a) then break;
    a := ah;
  end;
  result := a;
end;

// vZs
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  a, h, alpha, y : double;
  ch, loop : integer;
  epsilon, tmp : double;
begin
  val(labelededit1.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('aɊԈႢL܂B','',0);
    exit;
  end;
  val(labelededit2.Text, h, ch);
  if ch <> 0 then begin
    application.MessageBox('Ot͈hɊԈႢL܂B','',0);
    exit;
  end;
  if h <= 0 then begin
    application.MessageBox('Ot͈h[łB','',0);
    exit;
  end;

  // lvZ
  epsilon := 1;
  repeat
    epsilon := epsilon / 2;
    tmp := 1 + epsilon;
  until tmp = 1;
  epsilon := epsilon * 2;

  memo1.Clear;

  // l̊mF
  if abs(df(a)) < epsilon then begin
    memo1.lines.Append('ldf(a)̒l[ɐ܂');
    memo1.lines.Append('lύXĉB');
    exit;
  end;
  // `̌vZ
  loop := 0;
  alpha := newton_Method(a, epsilon, loop);
  if loop >= 1000 then begin
    memo1.lines.Append('܂łB');
    memo1.lines.Append('ĺAĉB');
    exit;
  end;
  // Z
  y := f(alpha);
  // vZʕ\
  memo1.Lines.Append('f(x) = x^2 - 2');
  memo1.Lines.Append('[v ' + intTostr(loop));
  memo1.Lines.Append('l');
  memo1.Lines.Append(floatTostr(epsilon));
  memo1.Lines.Append('f()=0');
  memo1.Lines.Append('= ' +floatTostr(alpha));
  memo1.Lines.Append('Z y = f()');
  memo1.Lines.Append('y= ' + floatTostr(y));
  // Ot쐬
  chart_graph(alpha, h);        // f(x)Ot
  series4.AddXY(alpha, y);      // 𓚒l
  series3.AddXY(a, f(a));       // l
end;

end.
